from __future__ import generators

def merge_simple(tree):
    """Try merge two peer nodes in the tree into one (in a simple minded
    way).  Return the number of merges done.
    """

    # "<I><B>a</B></I><I>b</I>" -> "<I><B>a</B>b</I>"
    #
    # still much too stupid since it can't do anything with:
    #
    # "<B><I>a</I></B><B>b</B>"

    if tree.tag is None:
        return 0 # ChunkNode
    merges = 0
    i = 0
    while i < len(tree.children)-1:
        a = tree.children[i]
        b = tree.children[i+1]
        if a.tag and a.tag == b.tag:
            a.children.extend(b.children) # add b's children to a
            del tree.children[i+1] # remove b
            merges += 1
        i += 1
    for child in tree.children:
        merges += merge_simple(child)
    return merges


def lift_simple_tag (tree, tag):
    """Move simple (tags the affect attributes that are independent of other
    attributes, like B) nodes as high in the tree as possible."""
    for child in tree.children:
        lift_simple_tag(child, tag)
    if len(tree.children) == 1 and tree.tag != tag:
        child = tree.children[0]
        if child.tag == tag:
            (tree.tag, child.tag) = (child.tag, tree.tag)
